package collectSongLyrics; 	

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.net.URL;

import org.lobobrowser.html.UserAgentContext;
import org.lobobrowser.html.domimpl.HTMLDocumentImpl;
import org.lobobrowser.html.parser.DocumentBuilderImpl;
import org.lobobrowser.html.parser.InputSourceImpl;
import org.lobobrowser.html.test.SimpleUserAgentContext;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;



public class ParsingURL {


	public static HTMLDocumentImpl getHTML(String TEST_URI) throws IOException, SAXException{
		
		    UserAgentContext uacontext = new SimpleUserAgentContext();
	        DocumentBuilderImpl builder = new DocumentBuilderImpl(uacontext);
	        URL url = new URL(TEST_URI);
	        InputStream in = url.openConnection().getInputStream();
	        HTMLDocumentImpl document;
	        try {
	            Reader reader = new InputStreamReader(in, "ISO-8859-1");
	            InputSourceImpl inputSource = new InputSourceImpl(reader, TEST_URI);
	            Document d = builder.parse(inputSource);
	            document = (HTMLDocumentImpl) d;
	        }
	        finally{
	        	in.close();
	        }
			return document;
	} 
	
	public static void main(String[] args) throws Exception {
	     
		
		System.out.println(ParsingURL.getHTML("http://www.absolutelyrics.com/lyrics/top50/").getElementsByTagName("ol").item(0).getChildNodes().item(0).getChildNodes().item(0));
	
	}
	
	
}
