package collectSongLyrics; 	

import java.io.File;
import java.io.IOException;
import org.lobobrowser.html.domimpl.HTMLDocumentImpl;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class SearchWikipedia { 

	 String genre;
	 String year;
	 String TEST_URI2 ;
	 
	 public SearchWikipedia(String artist, String title) throws IOException, SAXException{
	   
		 TEST_URI2 =URLUtils.addParameter("http://en.wikipedia.org/", "search", artist+" "+title);
         HTMLDocumentImpl document2 =ParsingURL.getHTML(TEST_URI2);
         NodeList uls=document2.getElementsByTagName("ul");
         String TEST_URI3=null;
         HTMLDocumentImpl document3=null;
  
    
     
         for(int k=1;k<uls.item(2).getChildNodes().getLength();k=k+2){
    	        
        	    boolean flag=true;
 	            String[] titles=title.split(" ");
 	            
 	            for(int t=1;t<titles.length;t++){
 	                      if(!uls.item(2).getChildNodes().item(k).getChildNodes().item(0).toString().contains(titles[t])&&!uls.item(2).getChildNodes().item(k).getChildNodes().item(0).toString().contains(titles[t].toLowerCase()))
 	    	              {	 
 	    		             flag=false;
 	    	                 break;
 	    	               }
 	            }
 	    
    	       if(flag==true)
 	           {     
 	        	      TEST_URI3="http://en.wikipedia.org"+uls.item(2).getChildNodes().item(k).getChildNodes().item(0);
 	                  if(TEST_URI3!=null){
                             document3 =ParsingURL.getHTML(TEST_URI3);
                             break;
 	                   }
 	           }
	      }
     
	
         NodeList tables=null;
         if(document3!=null)
                tables=document3.getElementsByTagName("table");
    
        if(tables!=null){     
              for(int i = 0; i < tables.item(0).getChildNodes().getLength(); i++) {
                     if(tables.item(0).getChildNodes().item(i).getTextContent().contains("Released"))
                           year=tables.item(0).getChildNodes().item(i).getTextContent().replace("Released", "");
                     if(tables.item(0).getChildNodes().item(i).getTextContent().contains("Genre")){ 
            	           genre=tables.item(0).getChildNodes().item(i).getTextContent().replace("Genre", "");
                     }     
    	       }      
       }
     
	}
	
	 
	 
	 public String getYear(){
		 return year;
	 }
	
	 public String getGenre(){
		 return genre;
	 }
	 
	 public String getURL(){
		 return TEST_URI2;
	 }
	 
	 public static void main(String[] args) throws Exception {
	     
		 File   fileDir  = new File("F:/Master Thesis/newLyrics/P" +
		 		"");
	     File[] textFiles  = fileDir.listFiles();
		 
	     
	     for(int k=0; k<textFiles.length;k++){
	    	    
	    	     String[] name=textFiles[k].getName().replace(".txt","").split("-");
	    	     String artist=name[0];
	    	     String title=name[1];
	           
	    	     System.out.println(artist+title);
	    	     SearchWikipedia search=new SearchWikipedia(artist,title);
	    	     
	    	    
		 
	    	     if(search.getYear()!=null){
	                  
	    	    	  char[] year=search.getYear().toCharArray();
	    	          String realyear=null;
	                  for(int i=0;i<year.length;i++){  
	            	         if((i+1)<year.length&&(i+2)<year.length&&(i+3)<year.length){
	            	                  if(Character.isDigit(year[i])&&Character.isDigit(year[i+1])&&Character.isDigit(year[i+2])&&Character.isDigit(year[i+3]))
	            	    	                realyear=Character.toString(year[i])+Character.toString(year[i+1])+Character.toString(year[i+2])+Character.toString(year[i+3]);
	            	          }
	                  }
	             
	                  File file;
	                  if(search.getGenre()!=null)
	                          file=new File("F:/Master Thesis/new/"+realyear+"_"+search.getGenre().substring(2,search.getGenre().length()-1)+"_"+"-"+artist+"-"+"albumn"+"-"+title+"-"+".txt");
	                  else
	                          file=new File("F:/Master Thesis/new/"+realyear+"_"+"Genre"+"_"+"-"+artist+"-"+"albumn"+"-"+title+"-"+".txt");
	                 textFiles[k].renameTo(file);    
	    	    } 
	     }  
	     
	     System.out.println("DONE");
	     
	     }
}