package fetchKeywords;




import fetchOpinionWords.SWN3;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

import opennlp.tools.lang.english.PosTagger;
import opennlp.tools.ngram.Dictionary;

import org.apache.uima.UimaContext;
import org.apache.uima.analysis_component.JCasAnnotator_ImplBase;
import org.apache.uima.analysis_engine.AnalysisEngineProcessException;
import org.apache.uima.cas.FSIterator;
import org.apache.uima.cas.text.AnnotationIndex;
import org.apache.uima.examples.opennlp.Sentence;
import org.apache.uima.examples.opennlp.Token;
import org.apache.uima.jcas.JCas;
import org.apache.uima.jcas.JCasRegistry;
import org.apache.uima.jcas.cas.TOP_Type;

import org.apache.uima.jcas.tcas.Annotation;


import org.apache.uima.resource.ResourceInitializationException;

import annotationType.KeywordsByTitleIn;


public class KeywordsByTitle extends JCasAnnotator_ImplBase {
     
  //public static final String MODEL_FILE_PARAM = "ModelFile";

 // private PosTagger tagger;
   
   
   File   fileDir  = new File("F:/Master Thesis/input");
   File[] textFiles  = fileDir.listFiles();
   public int i=0;
    
  /**
   * Initialize the Annotator.
   * 
   * @see JCasAnnotator_ImplBase#initialize(UimaContext)
   */
  public void initialize(UimaContext aContext) throws ResourceInitializationException {
    super.initialize(aContext);

    try {
      // Get configuration parameter values
  //    String modelFile = (String) aContext.getConfigParameterValue(MODEL_FILE_PARAM);
   //   tagger = new PosTagger(modelFile, (Dictionary) null);
    } catch (Exception e) {
      throw new ResourceInitializationException(e);
    }
  }

  /**
   * Process a CAS.
   * 
   * @see JCasAnnotator_ImplBase#process(JCas)
   */
  public void process(JCas aJCas) throws AnalysisEngineProcessException {
    
    ArrayList<Token> tokenList = new ArrayList<Token>();
    ArrayList wordList = new ArrayList();
    HashMap<Object,Integer> tokenList1 = new HashMap<Object,Integer>();
    
    if(i<textFiles.length){
    	
    String name=textFiles[i].getName();
    String[] string=name.split("-");
    String titlestring=string[3];
   
 
    String[] title=titlestring.split("_");
    
    	
    AnnotationIndex sentenceIndex = aJCas.getAnnotationIndex(Sentence.type);
    AnnotationIndex tokenIndex = aJCas.getAnnotationIndex(Token.type);

    // iterate over Sentences
    FSIterator sentenceIterator = sentenceIndex.iterator();
    while (sentenceIterator.hasNext()) {
    
     //  System.out.println("-------SENTENCE--------");
       	
      Sentence sentence = (Sentence) sentenceIterator.next();

  //    tokenList.clear();
    //  wordList.clear();

      // iterate over Tokens
      FSIterator tokenIterator = tokenIndex.subiterator(sentence);
     
      while (tokenIterator.hasNext()) {
       
    	Token token = (Token) tokenIterator.next();
        
    	tokenList.add(token);
      }
    }
        
    	//String posTag = token.getPosTag();
    	
    	/*
        if(posTag!=null&&posTag.equals("NN")||posTag.equals("NNS")||posTag.equals("NNP")||posTag.equals("NNPS")
        		||posTag.equals("VB")||posTag.equals("VBD")||posTag.equals("VBG")||posTag.equals("VBN")||posTag.equals("VBZ")
        		||posTag.equals("JJ")||posTag.equals("JJR")||posTag.equals("JJS")
        		||posTag.equals("RB")||posTag.equals("RBR")||posTag.equals("RBS"))
        	*/
    	
    	for(String w:title){
    		if(!w.toLowerCase().equals("a")&&!w.toLowerCase().equals("an")&&!w.toLowerCase().equals("the")){
    		System.out.println(w);
        	for(int i=0; i<tokenList.size();i++){
     			if(tokenList.get(i).getCoveredText().toLowerCase().equals(w.toLowerCase())){      
     		    KeywordsByTitleIn keywords=new KeywordsByTitleIn(aJCas); 
                keywords.setBegin(tokenList.get(i).getBegin());
                keywords.setEnd(tokenList.get(i).getEnd());
                keywords.addToIndexes();       
               }
           }
    	}
       }
    	i++;
    }
  }
}
