package fetchOpinionWords;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.HashMap;
import java.util.Vector;

public class SWN3 {
	//private String pathToSWN = "data"+File.separator+"SentiWordNet_3.0.0.txt";
	private String pathToSWN = "resources/SentiWordNet_3.0.0.txt";
	public double negative;
	public double positive;

	
	private HashMap<String, Vector<Double>> _dict;

	public SWN3(){

		_dict = new HashMap<String, Vector<Double>>();
		
		try{
			BufferedReader csv =  new BufferedReader(new FileReader(pathToSWN));
			String line = "";			
			while((line = csv.readLine()) != null)
			{
				
			if(!line.startsWith("#")){
				String[] data = line.split("\t");
				String[] words = data[4].split(" ");
				for(String w:words)
				{
					String[] w_n = w.split("#");
					if(w_n[1].equals("1")){
						Vector<Double> vector=new Vector<Double>();
				       	vector.add(Double.parseDouble(data[2]));	
						vector.add(Double.parseDouble(data[3]));
						w_n[0] += "#"+data[0];
						_dict.put(w_n[0], vector);
					}	  
				}
			}
			}
		}
		
		catch(Exception e){e.printStackTrace();}		
	}

	public Vector<Double> extract(String word, String pos)
	{
		return _dict.get(word+"#"+pos);
	}
	
	public double getNegScore(){
		return negative;
	}
	
    public double getPosScore(){
		return positive;
	}
    
    public double getNegScore(String word, String pos){
    	
    //   if(_dict.get(word+"#"+pos)!=null)
     	   return negative=_dict.get(word+"#"+pos).elementAt(1);
     // else 
     	//  return null;
 	    
	}
    
    public double getPosScore(String word, String pos){
    	
    	//if(_dict.get(word+"#"+pos)!=null)
    	   return positive=_dict.get(word+"#"+pos).elementAt(0);
    	//else 
    		//return null;
	    
    }

	
	
	public static void main(String args[]) throws Exception { 	
		System.out.println("!!!start!!!");
		SWN3 swn=new SWN3();
		System.out.println("!!!"+swn.extract("little", "a"));
		
	}
	
}
